org.eclipse.wst.jsdt.core

## Interface IJsGlobalScopeContainer

All Known Implementing Classes:
  BasicBrowserLibraryContainer, BasicBrowserLibraryJsGlobalScopeContainerInitializer, FireFoxLibInitializer, InternetExplorerLibInitializer, JREContainer, JREContainerInitializer, JsGlobalScopeContainerInitializer

    public interface IJsGlobalScopeContainer

Interface of a includepath container. A includepath container provides a way to indirectly reference a set of includepath entries through a includepath entry of kind `CPE_CONTAINER`. Typically, a includepath container can be used to describe a complex library composed of filess or projects, considering also that containers can map to different set of entries on each project, in other words, several projects can reference the same generic container path, but have each of them actually bound to a different container object.

The set of entries associated with a includepath container may contain any of the following:

- library entries (`CPE_LIBRARY`)
- project entries (`CPE_PROJECT`)

In particular, a includepath container can neither reference further includepath containers or includepath variables.

Classpath container values are persisted locally to the workspace, but are not preserved from a session to another. It is thus highly recommended to register a `JsGlobalScopeContainerInitializer` for each referenced container (through the extension point "org.eclipse.wst.jsdt.core.JsGlobalScopeContainerInitializer").

See Also:
  `Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.`

### Field Summary

Fields
`static int` `K_APPLICATION` Kind for a container mapping to an application library
`static int` `K_DEFAULT_SYSTEM` Kind for a container mapping to a default system library, implicitly contributed by the runtime
`static int` `K_SYSTEM` Kind for a container mapping to a system library

### Method Summary

All Methods Instance Methods Abstract Methods
`java.lang.String` `getDescription()` Answers a readable description of this container
`IIncludePathEntry[]` `getIncludepathEntries()` Answers the set of includepath entries this container is mapping to.
`int` `getKind()` Answers the kind of this container.
`IPath` `getPath()` Answers the container path identifying this container.
`java.lang.String[]` `resolvedLibraryImport(java.lang.String a)`

### Field Detail

#### K_APPLICATION

    static final int K_APPLICATION

Kind for a container mapping to an application library

See Also:
  Constant Field Values

#### K_SYSTEM

    static final int K_SYSTEM

Kind for a container mapping to a system library

See Also:
  Constant Field Values

#### K_DEFAULT_SYSTEM

    static final int K_DEFAULT_SYSTEM

Kind for a container mapping to a default system library, implicitly contributed by the runtime

See Also:
  Constant Field Values

### Method Detail

#### getIncludepathEntries

    IIncludePathEntry[] getIncludepathEntries()

Answers the set of includepath entries this container is mapping to.

The set of entries associated with a includepath container may contain any of the following:

- library entries (`CPE_LIBRARY`)
- project entries (`CPE_PROJECT`)

A includepath container can neither reference further includepath containers or includepath variables.

This method is called by the JavaScript model when it needs to resolve this includepath container entry into a list of library and project entries. The method is typically called exactly once for a given JavaScript project, and the resulting list of entries cached internally by the JavaScript model. This method must not be called by other clients.

There are a wide variety of conditions under which this method may be invoked. To ensure that the implementation does not interfere with correct functioning of the JavaScript model, the implementation should use only the following JavaScript model APIs:

- `JavaScriptCore.newLibraryEntry(IPath, IPath, IPath, boolean)` and variants
- `JavaScriptCore.newProjectEntry(IPath, boolean)` and variants
- `JavaScriptCore#create(org.eclipse.core.resources.IWorkspaceRoot)`
- `JavaScriptCore#create(org.eclipse.core.resources.IProject)`
- `IJavaScriptModel.getJavaScriptProjects()`
- `IJavaScriptProject.getRawIncludepath()`
- `IJavaScriptProject.readRawIncludepath()`
- `IJavaScriptProject#getOutputLocation()`
- `IJavaScriptProject#readOutputLocation()`
- JavaScript element operations marked as "handle-only"

The effects of using other JavaScript model APIs are unspecified.

Returns:
  IIncludePathEntry[] - the includepath entries this container represents
See Also:
  `IIncludePathEntry`

#### getDescription

    java.lang.String getDescription()

Answers a readable description of this container

Returns:
  String - a string description of the container

#### getKind

    int getKind()

Answers the kind of this container. Can be either:

- `K_APPLICATION` if this container maps to an application library
- `K_SYSTEM` if this container maps to a system library
- `K_DEFAULT_SYSTEM` if this container maps to a default system library (library implicitly contributed by the runtime).

Typically, system containers should be placed first on a build path.

Returns:
  the kind of this container

#### getPath

    IPath getPath()

Answers the container path identifying this container. A container path is formed by a first ID segment followed with extra segments, which can be used as additional hints for resolving to this container.

The container ID is also used to identify a`JsGlobalScopeContainerInitializer` registered on the extension point "org.eclipse.wst.jsdt.core.JsGlobalScopeContainerInitializer", which can be invoked if needing to resolve the container before it is explicitly set.

Returns:
  IPath - the container path that is associated with this container

#### resolvedLibraryImport

    java.lang.String[] resolvedLibraryImport(java.lang.String a)